# coding: utf-8

"""
    Akeyless API

    The purpose of this application is to provide access to Akeyless API.  # noqa: E501

    The version of the OpenAPI document: 2.0
    Contact: support@akeyless.io
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from akeyless.configuration import Configuration


class AllowedAccessArgs(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'access_id': 'str',
        'description': 'str',
        'name': 'str',
        'permissions': 'str',
        'sub_claims': 'dict(str, str)'
    }

    attribute_map = {
        'access_id': 'access-id',
        'description': 'description',
        'name': 'name',
        'permissions': 'permissions',
        'sub_claims': 'sub-claims'
    }

    def __init__(self, access_id=None, description=None, name=None, permissions=None, sub_claims=None, local_vars_configuration=None):  # noqa: E501
        """AllowedAccessArgs - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._access_id = None
        self._description = None
        self._name = None
        self._permissions = None
        self._sub_claims = None
        self.discriminator = None

        self.access_id = access_id
        if description is not None:
            self.description = description
        self.name = name
        if permissions is not None:
            self.permissions = permissions
        if sub_claims is not None:
            self.sub_claims = sub_claims

    @property
    def access_id(self):
        """Gets the access_id of this AllowedAccessArgs.  # noqa: E501

        Access ID The access id to be attached to this allowed access. Auth method with this access id should already exist.  # noqa: E501

        :return: The access_id of this AllowedAccessArgs.  # noqa: E501
        :rtype: str
        """
        return self._access_id

    @access_id.setter
    def access_id(self, access_id):
        """Sets the access_id of this AllowedAccessArgs.

        Access ID The access id to be attached to this allowed access. Auth method with this access id should already exist.  # noqa: E501

        :param access_id: The access_id of this AllowedAccessArgs.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and access_id is None:  # noqa: E501
            raise ValueError("Invalid value for `access_id`, must not be `None`")  # noqa: E501

        self._access_id = access_id

    @property
    def description(self):
        """Gets the description of this AllowedAccessArgs.  # noqa: E501

        Allowed access description  # noqa: E501

        :return: The description of this AllowedAccessArgs.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this AllowedAccessArgs.

        Allowed access description  # noqa: E501

        :param description: The description of this AllowedAccessArgs.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def name(self):
        """Gets the name of this AllowedAccessArgs.  # noqa: E501

        Allowed access name  # noqa: E501

        :return: The name of this AllowedAccessArgs.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this AllowedAccessArgs.

        Allowed access name  # noqa: E501

        :param name: The name of this AllowedAccessArgs.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def permissions(self):
        """Gets the permissions of this AllowedAccessArgs.  # noqa: E501

        Permissions  Comma-seperated list of permissions for this allowed access. Available permissions: [defaults,targets,classic_keys,automatic_migration,ldap_auth,dynamic_secret,k8s_auth,log_forwarding,zero_knowledge_encryption,rotated_secret,caching,event_forwarding,admin,kmip,general]  # noqa: E501

        :return: The permissions of this AllowedAccessArgs.  # noqa: E501
        :rtype: str
        """
        return self._permissions

    @permissions.setter
    def permissions(self, permissions):
        """Sets the permissions of this AllowedAccessArgs.

        Permissions  Comma-seperated list of permissions for this allowed access. Available permissions: [defaults,targets,classic_keys,automatic_migration,ldap_auth,dynamic_secret,k8s_auth,log_forwarding,zero_knowledge_encryption,rotated_secret,caching,event_forwarding,admin,kmip,general]  # noqa: E501

        :param permissions: The permissions of this AllowedAccessArgs.  # noqa: E501
        :type: str
        """

        self._permissions = permissions

    @property
    def sub_claims(self):
        """Gets the sub_claims of this AllowedAccessArgs.  # noqa: E501

        Sub claims key/val of sub claims, e.g group=admins,developers  # noqa: E501

        :return: The sub_claims of this AllowedAccessArgs.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._sub_claims

    @sub_claims.setter
    def sub_claims(self, sub_claims):
        """Sets the sub_claims of this AllowedAccessArgs.

        Sub claims key/val of sub claims, e.g group=admins,developers  # noqa: E501

        :param sub_claims: The sub_claims of this AllowedAccessArgs.  # noqa: E501
        :type: dict(str, str)
        """

        self._sub_claims = sub_claims

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AllowedAccessArgs):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AllowedAccessArgs):
            return True

        return self.to_dict() != other.to_dict()
